#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Change2CUI=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Dustin Wyatt

 Script Function:
	fishmech posted:
I'm looking for a Windows application that will randomly reorder the lines
in a specified text file and save the resulting text to optionally either the
original file or a new file.

#ce ----------------------------------------------------------------------------

; Script Start - Add your code below here
Global $usage = @ScriptName & " infile [outfile] " & @CRLF & "infile: shuffles line endings of this file " & @CRLF & "outfile: (optional) writes results to this file if specified, else rewrites to original file"
$inFileName = inFile()
$outFileName = outFile()

$f = FileOpen($inFileName, 0)	;Get the file handle
$lines = FileRead($f)		;Read it into memory
FileClose($f)
$lineSplit = StringSplit($lines, @CRLF, 1)	;Split the file into an array at Windows-style line endings
$lineSplit = shuffle($lineSplit)
$f = FileOpen($outFileName, 2)
For $row = 1 to UBound($lineSplit)-1
	FileWriteLine($f, $lineSplit[$row])
Next
FileClose($f)

Func inFile()
	If UBound($CmdLine) > 1 Then
		Return $CmdLine[1]
	EndIf
	ConsoleWrite($usage)
	Exit
EndFunc

Func outFile()
	If UBound($CmdLine) > 2 Then
		Return $CmdLine[2]
	Else
		Return inFile()
	EndIf
	ConsoleWrite($usage)
	Exit
EndFunc

Func shuffle($array)
	For $iRow = 1 To UBound($array)-1 ;for each cell...
		$rRow = Random(1, UBound($array)-1, 1) ;...select a random cell
		$Temp = $array[$iRow]	;switch the values in the cells
		$array[$iRow] = $array[$rRow]
		$array[$rRow] = $Temp
	Next
	Return $array
EndFunc